=== examples/OrcV2Examples/LLJITWithLazyReexports/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS
  Core
  ExecutionEngine
  IRReader
  OrcJIT
  Support
  nativecodegen
  )

add_llvm_example(LLJITWithLazyReexports
  LLJITWithLazyReexports.cpp
  )
