=== lib/CIR/Dialect/CMakeLists.txt ===
add_subdirectory(IR)
add_subdirectory(OpenACC)
add_subdirectory(Transforms)
